<template>
  <div class="template">
    <div class="formPostContainer">
      <form class="formPost">
        <div class="formPostElement">
          <label>Titre</label>
          <input
            id="title"
            type="text"
            name="title"
            placeholder="Entrer le titre de votre post"
            v-model="title"
            required
            @focusout="isTitleValid"
          />
          <p v-if="titleError == true">
            Le titre est obligatoire et doit contenir de 3 à 25 caractères
          </p>
        </div>
        <div class="formPostElement">
          <label>Description</label>
          <textarea
            rows="10"
            cols="50"
            id="description"
            type="text"
            name="description"
            placeholder="Entrer le texte de votre post"
            v-model="description"
            required
            @focusout="isDescriptionValid"
          ></textarea>
          <p v-if="descriptionError == true">
            La description est obligatoire et doit contenir de 5 à 255 caractères
          </p>
        </div>
        <div class="formPostElement">
          <label>Ajouter un fichier</label>
          <input
            type="file"
            accept=".png, .jpg, .jpeg, .gif, .mp4, .avi, .mp3"
            @change="uploadFiles($event.target.files)"
            id="attachment"
            name="attachment"
            placeholder="Télécharger une image ou une vidéo"
          />
        </div>

        <div class="formPostElement">
          <button
            id="publish"
            type="submit"
            @click="publish"
            :disabled="validatedFields == false"
          >
            Publier
          </button>
        </div>
      </form>
    </div>
  </div>
</template>

<script>
import axios from "axios";
import { mapState } from "vuex";

export default {
  name: "PublishView",
  data() {
    return {
      title: "",
      description: "",
      attachment: "",
      titleError: "",
      descriptionError: "",
      titleMinlength: 2,
      descriptionMinlength: 4,
      titleMaxlength: 25,
      descriptionMaxlength: 255,
    };
  },

  computed: {
    ...mapState(["status"]),
    validatedFields() {
      if (this.title !== "" && this.description !== "") {
        return true;
      } else {
        return false;
      }
    },
  },

  methods: {
    uploadFiles(files) {
      this.attachment = files[0];
    },
    getFormData() {
      let formData = new FormData();
      formData.append("title", this.title);
      formData.append("description", this.description);
      formData.append("attachment", this.attachment);
      return formData;
    },
    publish(e) {
      e.preventDefault();
      const token = this.$store.state.user.token;
      const formData = this.getFormData();
      axios
        .post("http://localhost:3000/api/posts/create", formData, {
          headers: {
            Authorization: `Basic ${token}`,
            "Content-Type": "multipart/form-data",
          },
        })
        .then((request) => {
          console.log(request.data);
          alert("Votre post est publié");
          this.$router.push("/network");
        })
        .catch((error) => {
          console.log(error);
          alert("Publication impossible");
        });
    },
    isTitleValid() {
      if (
        this.title == "" ||
        this.title.length <= this.titleMinlength ||
        this.title.length >= this.titleMaxlength
      ) {
        this.titleError = true;
      } else {
        this.titleError = false;
      }
    },
    isDescriptionValid() {
      if (
        this.description == "" ||
        this.description.length <= this.descriptionMinlength ||
        this.description.length >= this.descriptionMaxlength
      ) {
        this.descriptionError = true;
      } else {
        this.descriptionError = false;
      }
    },
  },
};
</script>

<style lang="scss" scoped>
.template {
  background-image: url("../assets/logos/icon.svg");
  background-attachment: fixed;
  background-repeat: no-repeat;
}
.formPost {
  font-size: large;
  text-align: start;
  &Element {
    display: grid;
    grid-template-columns: 1fr 2fr;
    justify-content: space-around;
    align-items: center;
    margin: 50px;
    padding: 20px;
  }
}
label,
input,
button {
  display: block;
}

input type[placeholder] {
  font-size: smaller;
}

label, p {
  padding-left: 20px;
}
#title,
#description,
#publish {
  font-family: Monserrat, Arial, sans-serif;
  font-weight: lighter ;
  border-radius: 40px;
  border: solid 1px blue;
  width: 300px;
  height: 50px;
  font-size: 0.9rem;
  padding-left: 10px;
  &:hover {
    background-color: rgb(216, 217, 231);
    font-weight: bold;
  }
}

button {
  grid-column: 2;
  &:hover {
    background-color: blue;
    color: white;
  }
}
p {
  color: rgb(94, 5, 5);
  font-style : italic;
  font-weight: lighter;
}
@media screen and (max-width: 660px) {
  .template {
    padding-top: 150px;
  }
  input,
  button {
    display: block;
  }
  .formPost {
    display: flex;
    flex-direction: column;
    justify-content: center;
    align-items: center;
    &Element {
      display: flex;
      flex-direction: column;
      margin: 20px;
      padding: 10px;
    }
  }
}
</style>
